/* Low-Level.C - Machine specific procedures/defines/etc */
#include "lsdino.h"

void delay(unsigned long l)
{
        int i;

        while(l--)
                for(i=0;i<1000;i++)
                        ;
}


void waitretrace(void)
{
     asm{
          mov dx,3dah
retrace:
          in al,dx
          and al,8
          jz retrace
     }
}

void vgamode(void)
{
        disp_open();
        screenbuffer=(char far *) _x386_mk_protected_ptr(0xA0000);
        disp_setmode(0x13);
}

void txtmode(void)
{
        disp_setmode(0x03);
        disp_close();
}

unsigned char getpix(int x,int y)
{
        return(*(screenbuffer+y*320+x));
}

void putpix(int x,int y,unsigned char color)
{     
        if(color==0)
                color++;        
        *(screenbuffer+y*320+x)=color;
}


void rgb(unsigned char color, char r, char g, char b)
{
        outp(0x3c8,color);
        outp(0x3c9,r);
        outp(0x3c9,g);
        outp(0x3c9,b);
}



void update_dac(void)
{
        int i;
                         
       waitretrace();
asm    cli
       for(i=0;i<256;i++)
                rgb(i,dacbox[i][0],dacbox[i][1],dacbox[i][2]);
asm    sti
}


